#include "chario.h"


static int char_buff[MAX_BUFFERED_CHARS];
static int buff_pos = 0;


int GetChar(void)
{
   if(buff_pos)
   {
      buff_pos--;
      return char_buff[buff_pos];
   }
   return getchar();
}

int LookChar(void)
{
   int c = GetChar();

   PushChar(c);
   return c;
}

int PushChar(int c)
{
   if(buff_pos < MAX_BUFFERED_CHARS)
   {
      char_buff[buff_pos] = c;
      buff_pos++;
      return c;
   }
   return EOF;
}

int SkipSpace(void)
{
   int c;

   while(isspace((c=GetChar())))
   { /* Empty body */ }
   return PushChar(c);
}
