#include "integerio.h"


/* Consider c as a hexadecimal digit (0..9, a..f, A..F) and return its
   numerical value. If not a valid digit, return -1 */
static int hex_digit_value(int c)
{
   if(c >= '0' && c <= '9')
   {
      return c - '0';
   }
   if(c >= 'a' && c <= 'f')
   {
      return c - 'a' + 10;
   }
   if(c >= 'A' && c <= 'F')
   {
      return c - 'A' +10;
   }
   return -1;
}

/* Check if a character c is a valid digit in base. */
static int is_base_digit(int c, int base)
{
   int value = hex_digit_value(c);
   
   if(value < 0 || value >= base)
   {
      return 0;
   }
   return 1;
}

/* Given an int 0<= value < 16, return the Hexadecimal digit with that
   value */
static int int_to_hexdigit(int value)
{
   if(value<=9)
   {
      return value + '0';
   }
   else
   {
      return value - 10 + 'A';
   }
}


/* Read an integer in base base. */
int read_int_base(int base)
{
   int res = 0, c, sign = 1;
   
   if((c=GetChar())=='-')
   {
      sign = -1;
   }
   else
   {
      PushChar(c); /* Unread Character */
   }
   while(is_base_digit((c=GetChar()),base))
   {
      res = (res*base)+hex_digit_value(c);
   }
   PushChar(c);
   return res*sign;   
}

/* Check if there is a integer to be read, i.e. a digit or '-'
   directly followed by a digit */
int int_available(int base)
{
   int save_char , res = 0;

   if(is_base_digit(LookChar(), base))
   {
      res = 1;
   }
   else if(LookChar() == '-')
   {
      save_char = GetChar();
      if(is_base_digit(LookChar(), base))
      {
	 res = 1;
      }
      PushChar(save_char);
   }
   return res;
}

/* Write integer in any base (2<= base <=16) to stdout */
void write_int_base(int value, int base)
{
   int digit;
   
   if(value < 0)
   {
      putchar('-');
      value = -1*value;
   }      
   digit = value % base;
   value = value/base;
   
   if(value!=0)
   {
      write_int_base(value, base);
   }
   putchar(int_to_hexdigit(digit));
}









